<template>
    <div class="SplitBatch">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">分割批次</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getSplitBatchList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTableSplitBach"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                    @selection-change="handleSelectionChange"
                    :row-key="getRowKeys"
                >
                    <el-table-column type="selection" :reserve-selection="true" width="55"></el-table-column>
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="carcassCode" label="胴体编码" width="180"></el-table-column>
                    <el-table-column prop="weight" label="重量(kg)" width="180"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" style="padding-top: 20px">
                    <el-col>
                        <el-button @click="toggleSelection()">取消选择</el-button>
                        <el-button type="primary" plain @click="createBatch">
                            生产批次
                            <i class="el-icon-arrow-right el-icon--right"></i>
                        </el-button>
                    </el-col>
                    <el-col :span="8">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form
                        ref="addSplitBatch"
                        :model="formData"
                        :rules="rules"
                        label-width="140px"
                    >
                        <el-form-item label="胴体编码">
                            <el-input v-model="formData.carcassCode"></el-input>
                        </el-form-item>

                        <el-form-item label="重量">
                            <el-input v-model="formData.weight"></el-input>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addSplitBatch')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>

        <el-dialog title="创建批次" :visible.sync="isShowCreateBatch" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form label-width="140px">
                        <el-form-item label="胴体编码">
                            <el-input v-model="operator"></el-input>
                        </el-form-item>
                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="saveCreateBatch">确 定</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqSplitBatchList,
    reqAddSplitBatch,
    reqUpdateSplitBatch,
    reqDelSplitBatch,
    reqCreateBatch
} from "@/api/slaughterManagment.js";

const pageSize = 10;
const rules = {};

export default {
    name: "SplitBatch",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                carcassCode: "1006",
                weight: "32"
            },
            getRowKeys(row) {
                return row.id;
            },
            isShowCreateBatch: false,
            multipleSelection: [],
            operator: "张亚洲",
            isAdd: false,
            rules
        };
    },
    created() {
        // 分割批次列表
        this.getSplitBatchList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddSplitBatch(this.formData)
                            .then(res => {
                                // 分割批次列表
                                this.getSplitBatchList();
                                this.$message.success("添加成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateSplitBatch(this.formData)
                            .then(res => {
                                // 分割批次列表
                                this.getSplitBatchList();
                                this.$message.success("编辑成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 分割批次列表
        getSplitBatchList() {
            reqSplitBatchList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },

        toggleSelection(rows) {
            if (rows) {
                rows.forEach(row => {
                    this.$refs.multipleTableSplitBach.toggleRowSelection(row);
                });
            } else {
                this.$refs.multipleTableSplitBach.clearSelection();
            }
        },
        handleSelectionChange(val) {
            this.multipleSelection = val.map(item => item.id);
        },
        add() {
            this.isShow = true;
            this.isAdd = true;
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false;
        },
        del(row) {
            reqDelSplitBatch(row.id)
                .then(res => {
                    console.log(res);
                    // 分割批次列表
                    this.getSplitBatchList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        createBatch() {
            if (this.multipleSelection.length <= 0) {
                this.$message.warning("请选择胴体");
                return;
            }
            this.isShowCreateBatch = true;
        },
        saveCreateBatch() {
            reqCreateBatch({
                ids: this.multipleSelection.toString(),
                operator: this.operator
            })
                .then(res => {
                    console.log(res);
                    if (res.errCode) {
                        this.$message.error(res.errMsg);
                    } else {
                        // 分割批次列表
                        this.getSplitBatchList();
                        this.$message.success("创建批次成功！");
                        this.isShowCreateBatch = false
                    }
                })
                .catch(err => {
                    console.error(err);
                });
        },
        pageChange(p) {
            this.page = p;
            // 分割批次列表
            this.getSplitBatchList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
</style>